import { Component, EventEmitter, Input, Output } from '@angular/core';
import { SlutredovisningResponseMainOccupationDetails } from '@msfa-models/api/slutredovisning.response.model';
import { DeltagareAvrop } from '@msfa-models/avrop.model';
import { CustomError } from '@msfa-models/error/custom-error';
import { MainOccupation, Slutredovisning } from '@msfa-models/slutredovisning.model';
import { BehaviorSubject } from 'rxjs';
import { map } from 'rxjs/operators';
import { SlutredovisningFormData } from '../models/slutredovisning-form-data.model';
import { SlutredovisningFormService } from '../slutredovisning-form.service';
import { slutredovisningFormDataToSlutredovisningRequest } from '../utils/form-data-to-slutredovisning.util';

@Component({
  selector: 'msfa-slutredovisning-form-step3',
  templateUrl: './slutredovisning-form-step3.component.html',
  styleUrls: ['./slutredovisning-form-step3.component.scss'],
})
export class SlutredovisningFormStep3Component {
  @Output() backClick = new EventEmitter<void>();
  @Input() slutredovisningFormData: SlutredovisningFormData;
  @Input() avrop: DeltagareAvrop;

  submitIsLoading$ = new BehaviorSubject<boolean>(false);
  submitError$ = new BehaviorSubject<CustomError>(null);
  submittedDate$ = new BehaviorSubject<Date | null>(null);

  slutredovisning$ = this.slutredovisningFormService.yrkeToTextMap$.pipe(
    map(yrkeToText => this._appendYrkeNames(this.slutredovisningFormData, yrkeToText))
  );

  private _appendYrkeNames(
    slutredovisningFormData: SlutredovisningFormData,
    yrkeToText: { [key: string]: string }
  ): Slutredovisning {
    if (slutredovisningFormData.mainOccupation.type !== MainOccupation.Work) {
      return slutredovisningFormData as Slutredovisning;
    }

    const newMainOccupation: SlutredovisningResponseMainOccupationDetails = {
      ...slutredovisningFormData.mainOccupation,
      work: slutredovisningFormData.mainOccupation.work.map(yrke => ({
        ...yrke,
        yrkesomradeName: yrkeToText[yrke.yrkesomrade],
        yrkesgruppName: yrkeToText[yrke.yrkesgrupp],
      })),
    };
    return { ...slutredovisningFormData, mainOccupation: newMainOccupation };
  }

  goBack(): void {
    this.backClick.emit();
  }

  constructor(private slutredovisningFormService: SlutredovisningFormService) {}

  submitSlutredovisning(): void {
    this.submitIsLoading$.next(true);

    const toBeSubmitted = slutredovisningFormDataToSlutredovisningRequest(this.slutredovisningFormData);
    this.slutredovisningFormService.submitSlutredovisning$(toBeSubmitted).subscribe({
      next: () => {
        this.submitIsLoading$.next(false);
        this.submittedDate$.next(new Date());
      },
      error: (customError: CustomError) => {
        this.submitError$.next({ ...customError, message: customError.error.message });
        this.submitIsLoading$.next(false);
        throw { ...customError, avoidToast: true };
      },
    });
  }
}
